//-----------------------------------------------------------------------------
//
//  Simulator Bob, Copyright (C) 2003-2005 Patrik Stellmann 
//  All rights reserved.
//  
//  email: <stellmann@users.sourceforge.net> web: <simbob.sourceforge.net>
//
//  This program/file is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details. (http://www.gnu.org)
//
//-----------------------------------------------------------------------------
//
//  $Author: $
//
//  $Date: $
//
//  $Revision: $
//
//  $Source: $
//
//-----------------------------------------------------------------------------
//
//  $Log: $
//-----------------------------------------------------------------------------
#ifndef FOLLOWWALLCONTROLLER_HPP
#define FOLLOWWALLCONTROLLER_HPP

class DLLINTERFACE RCFollowWallController	:
	public TRCControllerComponent<RCFollowWallController>
{
public:	
	RCFollowWallController(
		const RCString&				sKey,
		const RSControllerCtorArg&	CtorArg);

	virtual ~RCFollowWallController();

	virtual void Realize();
	virtual void Clear();

protected:
	TLong ThreadFcn(void*);

protected:
	MRtlNoInterface(RCFollowWallController, TRCControllerComponent<RCFollowWallController>)

	MParamMembersStart(RCFollowWallController)
		MParamMember("LeftSensor",		m_LeftSensorPtr,	RCComponentPointerParamHandler)
		MParamMember("RightSensor",		m_RightSensorPtr,	RCComponentPointerParamHandler)
		MParamMember("MotionControl",	m_MotionControlPtr,	RCComponentPointerParamHandler)
		MParamMember("LinVelocity",		m_nLinVelocity,		RCRealParamHandler(0.01, 10, 0.01, 1.0,  _T("m/s")))
		MParamMember("RotVelocity",		m_nRotVelocity,		RCRealParamHandler(0.01, 50, 0.01, 1.0,  _T("r/s")))
		MParamMember("Period",			m_nPeriod,			RCRealParamHandler(0.01, 10, 0.01, 1000, _T("ms")))
    MParamMembersEnd()

protected:
	typedef TRCRtlComponentPointer<RCContactSensor>		TContactSensorPtr;
	typedef TRCRtlComponentPointer<RC2DMotionControl>	T2DMotionControlPtr;

	//	parameters:
	TContactSensorPtr	m_LeftSensorPtr;
	TContactSensorPtr	m_RightSensorPtr;
	T2DMotionControlPtr	m_MotionControlPtr;
	TReal				m_nLinVelocity;
	TReal				m_nRotVelocity;
	TReal				m_nPeriod;

	//	members:
	TThreadPtr	m_ThreadPtr;

private:
	RCFollowWallController(const RCFollowWallController&);
	RCFollowWallController& operator=(const RCFollowWallController&);
};


#include "followwallcontroller.inl"

#endif	//	FOLLOWWALLCONTROLLER_HPP
